package at.gv.egiz.simpleSigning;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.OutputStream;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.io.FileUtils;
import org.apache.log4j.BasicConfigurator;
import org.apache.log4j.PropertyConfigurator;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import at.gv.egiz.simpleSigning.cfg.Configuration;

public class PDFASJsServlet extends HttpServlet {

	/**
	 * 
	 */
	private static final long serialVersionUID = -2069326194649859734L;

	private static final Logger logger = LoggerFactory
			.getLogger(PDFASJsServlet.class);

	private static final String DEFAULT_LOG4J_ENV = "log4j.configuration";

	public PDFASJsServlet() {
		super();
		Configuration.configure();

		try {
			PropertyConfigurator.configure(new FileInputStream(Configuration.getLog4J()));
			logger.info("Configured Log4j with: " + Configuration.getLog4J());
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			System.err
					.println("Failed to initialize logging System. Defaulting to basic configuration!");
			BasicConfigurator.configure();
		}

	}

	@Override
	protected void doGet(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		doProcess(req, resp);
	}

	protected void doProcess(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		String pdfJS = FileUtils.readFileToString(FileUtils
				.toFile(PDFASJsServlet.class.getResource("/js/pdfas.js")));

		pdfJS = pdfJS.replace("##REPLACE##CONTEXT##",
				Configuration.getPublicContext());
		pdfJS = pdfJS.replace("##REPLACE##DOMAIN##",
				Configuration.getPublicHost());

		String postman = FileUtils.readFileToString(FileUtils
				.toFile(PDFASJsServlet.class.getResource("/js/postman.js")));

		resp.setContentType("text/javascript");
		OutputStream os = resp.getOutputStream();
		os.write(postman.getBytes());
		os.write(pdfJS.getBytes());
		os.close();
	}

}
