<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<script type="text/javascript" src="pdfas.js"></script>

<script type="text/javascript">
	function clearDiv() {
		document.getElementById("embedded").innerHTML = "";
		document.getElementById("btnSign").disabled = false;
	}

	function signWidthContent() {

		document.getElementById("btnSign").disabled = true;
		
		document.getElementById("Error").style.display = "none";
		document.getElementById("Result").style.display = "none";

		var valueContent = document.getElementById("txtContent").value;

		var op = {
			content : valueContent
		};

		var dispOption = document.getElementById("disp");

		if (dispOption.options[dispOption.selectedIndex].value == "EMBEDDED") {
			op.uiId = "embedded";
		}

		var bkuSel = document.getElementById("bkusel");
		
		if (bkuSel.options[bkuSel.selectedIndex].value != "NONE") {
			op.connector = bkuSel.options[bkuSel.selectedIndex].value;
		}
		
		var typeOption = document.getElementById("type");

		if (typeOption.options[typeOption.selectedIndex].value == "TEXT") {
			pdfAs.signText(op, function(code, msg) {
				var element = document.getElementById("Error");
				element.innerHTML = "<p>Error: " + code + " (" + msg + ")</p>";
				element.style.display = "block";
				clearDiv();
			}, function(pdfurl) {
				var element = document.getElementById("Result");
				element.innerHTML = "<a href=\"" + pdfurl + "\">ready</a>";
				element.style.display = "block";
				clearDiv();
			});
		} else {
			pdfAs.signPdf(op, function(code, msg) {
				var element = document.getElementById("Error");
				element.innerHTML = "<p>Error: " + code + " (" + msg + ")</p>";
				element.style.display = "block";
				clearDiv();
			}, function(pdfurl) {
				var element = document.getElementById("Result");
				element.innerHTML = "<a href=\"" + pdfurl + "\">ready</a>";
				element.style.display = "block";
				clearDiv();
			});
		}
		// so we don't follow the form ...
		return false;
	}
	
	function showVersion() {
		pdfAs.getVersion(function show(version) {
			alert("Version: " + version.version + " SCM: " + version.scm);
		}, function error(error) {
			alert("Failed to get Version: " + error);
		});
		// so we don't follow the form ...
		return false;
	}
</script>
<!-- Bootstrap core CSS -->
<link href="css/bootstrap.min.css" rel="stylesheet">
</head>
<body>
	<div class="container">
		<div class="row marketing">
			<div class="col-12">
				<h2>Einfach signieren mit JavaScript</h2>

				<p>Dieses Tool bietet eine einfach zu integrierende JavaScript
					Bibliothek, mit der beliebiger Text bzw. PDF Dokumente mit der
					Handy-Signatur bzw. B&uuml;rgerkarte signiert werden k&ouml;nnen.</p>
				<p>Die JavaScript Bibliothek bzw. die PDF Signaturtools werden
					&uuml;ber die Seite B&uuml;rgerkarte.at zentral angeboten und
					k&ouml;nnen &uuml;ber diese in wenigen Schritten in beliebige
					Webseiten integriert werden.</p>

			</div>
		</div>
		<hr>
		<div class="row marketing">
			<div class="col-lg-6">

				<p>Hier ein Beispiel welches Einfach signieren
					verwendet.</p>

				<hr>

				<div class="alert alert-danger" role="alert" id="Error"
					style="display: none"></div>

				<div class="alert alert-success" role="alert" id="Result"
					style="display: none"></div>

				<form role="form">
					<div class="form-group">
						<label for="type">Dokumententyp: </label> <select id="type">
							<option value="TEXT">Text</option>
							<option value="PDF">PDF</option>
						</select>
					</div>
					<div class="form-group">
						<label for="disp">Integration: </label> <select id="disp">
							<option value="DIALOG">Dialog</option>
							<option value="EMBEDDED">Embedded</option>
						</select>
					</div>
					<div class="form-group">
						<label for="bkusel">BKU Auswahl (optional): </label> <select id="bkusel">
							<option value="NONE">Keine</option>
							<option value="mobilebku">Handy</option>
							<option value="bku">Lokal mit Signaturkarte</option>
							<option value="onlinebku">Signaturkarte</option>
						</select>
					</div>
					<div class="form-group">
						<label for="txtContent">Signaturdaten (Text oder Link zu
							einem PDF Dokument, optional): </label> <input type="text" id="txtContent">
					</div>
					<div class="form-group">
						<button id="btnSign" onclick="return signWidthContent();">Unterschreiben</button>
					</div>
					<div class="form-group">
						<button id="btnVersion" onclick="return showVersion();">zeige Version</button>
					</div>
				</form>

			</div>

			<div class="col-lg-6" id="embedded"></div>
		</div>
		<hr>
		<div class="row marketing">
			<div class="col-12">
				<h4>Technische Anleitung zur Verwendung der JavaScript
					Bibliothek:</h4>
				<p>Inkludieren der JavaScript Bibliothek:</p>

				<p><code>&lt;script type=&quot;text/javascript&quot;
					src=&quot;https://www.buergerkarte.at/einfach-signieren/pdfas.js&quot;&gt;&lt;/script&gt;</code></p>

				<p>Diese Bibliothek erzeugt ein JavaScript Objekt pdfAs. Dieses
					Objekt hat zwei Funktionen signText und signPdf.</p>

				<p>
					signText wird verwendet um einfach Text zu signieren, dabei wird
					automatisch ein PDF Dokument erzeugt, welches den Text als Inhalt
					hat:<br> 
					<code>
					&lt;script type=&quot;text/javascript&quot;&gt;<br>
					&nbsp;&nbsp;var op = {<br> 
					&nbsp;&nbsp;&nbsp;&nbsp;content: &quot;Der zu signierende Text&quot;,
					// Diese Eigenschaft ist optional, wenn ausgelassen wird dem
					Benutzer ein Texteingabefeld gezeigt. Dies ist der Inhalt der
					signiert werden soll.<br>
					&nbsp;&nbsp;&nbsp;&nbsp;connector: &quot;bku&quot;, // Diese
					Eigenschaft ist optional, wenn ausgelassen wird dem Benutzer
					gefragt. Moegliche Werte sind: &quot;bku&quot; -&gt; Signatur mit
					der lokalen BKU, &quot;onlinebku&quot; -&gt; Signatur mit der
					online BKU, &quot;mobilebku&quot; -&gt; Signatur mit der Handy
					Signatur<br> 
					&nbsp;&nbsp;&nbsp;&nbsp;uiId: &quot;exampleDiv&quot; // Diese Eigenschaft
					ist optional, wenn ausgelassen wird ein Overlay erzeugt. Dies ist
					die id eines div elements in das das iframe zur Benutzerinteraktion
					eingefuegt werden soll.<br>&nbsp;&nbsp; };<br> &nbsp;&nbsp;pdfAs.signText(op,
					function(error, cause) {<br> &nbsp;&nbsp;&nbsp;&nbsp;//fehler error aufgetreten wegen
					cause <br> &nbsp;&nbsp;}, function(pdfurl) { <br> &nbsp;&nbsp;&nbsp;&nbsp;//signiertes
					Dokument liegt bei pdfurl<br> &nbsp;&nbsp;});<br> &lt;/script&gt;
					</code>
				</p>

				<p>
					signPdf wird verwendet um ein PDF Dokument zu signieren:<br>
					<code>
					&lt;script type=&quot;text/javascript&quot;&gt;<br> 
					&nbsp;&nbsp;var op = {<br>
					&nbsp;&nbsp;&nbsp;&nbsp;content: &quot;http://www.example.com/test.pdf&quot;, // Diese
					Eigenschaft ist optional, wenn ausgelassen wird dem Benutzer ein
					File Upload angezeigt. Dies ist eine URL zum PDF Dokument welches
					signiert werden soll.<br> 
					&nbsp;&nbsp;&nbsp;&nbsp;connector: &quot;bku&quot;, // Diese
					Eigenschaft ist optional, wenn ausgelassen wird dem Benutzer
					gefragt. Moegliche Werte sind: &quot;bku&quot; -&gt; Signatur mit
					der lokalen BKU, &quot;onlinebku&quot; -&gt; Signatur mit der
					online BKU, &quot;mobilebku&quot; -&gt; Signatur mit der Handy
					Signatur<br> 
					&nbsp;&nbsp;&nbsp;&nbsp;uiId: &quot;exampleDiv&quot; // Diese Eigenschaft
					ist optional, wenn ausgelassen wird ein Overlay erzeugt. Dies ist
					die id eines div elements in das das iframe zur Benutzerinteraktion
					eingefuegt werden soll.<br> 
					&nbsp;&nbsp;};<br> 
					&nbsp;&nbsp;pdfAs.signPdf(op,
					function(error, cause) {<br> 
					&nbsp;&nbsp;&nbsp;&nbsp;//fehler error aufgetreten wegen
					cause <br>
					&nbsp;&nbsp; }, function(pdfurl) {<br>
					&nbsp;&nbsp;&nbsp;&nbsp; //signiertes
					Dokument liegt bei pdfurl<br> 
					&nbsp;&nbsp;});<br> 
					&lt;/script&gt;
					</code>
				</p>
			</div>
		</div>

		<hr>

		<div class="footer">
			<p>&copy; EGIZ 2014</p>
		</div>

	</div>
	<!-- /container -->
	<script src="jquery.js"></script>
	<script src="js/bootstrap.min.js"></script>
</body>
</html>